require 'TimerEvent'

module WorkTimer

class EventContainer
   attr_reader :startEvents
   attr_reader :stopEvents
   
   def initialize()
      @startEvents = Array.new
      @stopEvents = Array.new
   end
   
   def addEvent(anEvent)
      if anEvent.eventType == "Start"
         @startEvents.push(anEvent)
      else
         @stopEvents.push(anEvent)
      end
   end
   
   def computeTimeSpent(stTime, enTime)
      #make sure the lists are sorted
      @startEvents.sort! { |x,y| x.eventTime <=> y.eventTime }
      @stopEvents.sort! { |x,y| x.eventTime <=> y.eventTime }
      
      timeSpent = 0
            
      startEvents.each_index {
         |index|
         startTime = @startEvents[index].eventTime
                  
         if @stopEvents.size < index + 1
            endTime = Time.now.to_i
         else
            endTime = @stopEvents[index].eventTime
         end
         
         # need to account for situations in which an activity
         # was begun on one day and completed on another
         if startTime < enTime and startTime >= stTime and
            endTime >= enTime
            endTime = enTime - 1
         elsif endTime < enTime and endTime >= stTime and
               startTime < stTime
            startTime = stTime
         end
         
         if startTime >= stTime and startTime <  enTime and
            endTime >= stTime and endTime < enTime
            timeSpent += endTime - startTime
         end
      }
      
      return timeSpent
   end
end

end